import { ProcfileReconciler } from './ProcfileReconciler';
import { ProcessRepresentationChainModifier } from './ProcessRepresentationChainModifier';
/**
 * Class ProcfileReconcilerAccessor
 * A easy way to access ProcfileReconciler
 */
export declare class ProcfileReconcilerAccessor {
    private procfileReconciler;
    readonly dev: boolean;
    readonly appName: string;
    readonly appDir: string;
    constructor(procfileReconciler: ProcfileReconciler);
    /**
     * define process
     * @param processName
     * @return {ProcessRepresentationChainModifier}
     */
    process(processName: string): ProcessRepresentationChainModifier;
    /**
     * Define fork a process
     * @param processName
     * @param entryFile
     * @return {ProcessRepresentationChainModifier}
     */
    fork(processName: string, entryFile: any): ProcessRepresentationChainModifier;
    private clusterCount;
    /**
     * @param path
     * @return {ProcessRepresentationChainModifier}
     */
    cluster(entryFile: any): ProcessRepresentationChainModifier;
    cluster(processName: string, entryFile: any): ProcessRepresentationChainModifier;
}
